/**
 * 活动模块（路演）
 */
import {httpGet,httpPost} from "@/utils/request.js"

/**
 * 列表
 * @param {int}  PageSize  每页数据条数
 * @param {int}  CurrentIndex 当前页页码，从1开始
 * @param {string}  Status  状态：1:待接受,2:包含，已接受,已拒绝(3),已删除(4) 
 */
export const apiRoadShowList=params=>{
    return httpGet('/roadshow/calendar/list',params)
}

/**
 * 详情
 * @param {int}  RsCalendarId 路演活动id
 * @param {int}  RsCalendarResearcherId  活动研究员id
 */
export const apiRoadShowInfo=params=>{
    return httpGet('/roadshow/calendar/detail',params)
}

/**
 * 审批 通过
 * @param {int}  RsCalendarId 路演活动id
 * @param {int}  RsCalendarResearcherId  活动研究员id
 */
 export const apiRoadShowApproved=params=>{
	return httpPost('/roadshow/accept',params)
}

/**
 * 审批 拒绝
 * @param {int}  RsCalendarId 路演活动id
 * @param {int}  RsCalendarResearcherId  活动研究员id
 * @param {string} RefuseReason 理由  
 */
export const apiRoadShowReject=params=>{
	return httpPost('/roadshow/refuse',params)
}